-- a black/white mask image: black pixels will mask, white pixels will pass.
local mask = love.graphics.newImage("mymask.png")
local test = love.graphics.newImage("test.png")
 
local mask_shader = love.graphics.newShader[[
   vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords) {
      if (Texel(texture, texture_coords).rgb == vec3(1.0)) {
         // a discarded pixel wont be applied as the stencil.
         discard;
      }
      return vec4(0.0);
   }
]]
 
local function myStencilFunction()
	love.graphics.setShader(mask_shader)
	love.graphics.draw(mask, 0, 0)
	love.graphics.setShader()
end
 
function love.draw()
	love.graphics.draw(test, 0, 0)

	love.graphics.stencil(myStencilFunction, "replace", 1)
	love.graphics.setStencilTest("greater", 0)
	love.graphics.rectangle("fill", 0, 0, 640, 480)
	love.graphics.setStencilTest()
end